import * as cli from "https://deno.land/std@0.219.0/cli/mod.ts";

const USAGE = `mbztr_gen_module - Interactively generate a MBZTR module.

Usage:
    mbztr_gen_module [options] <name> [...file]

Arguments:
    name  Name for the module.
    file  List of files or directories in the module.

Options:
    --help, -h  Prints help message.
`;

async function main() {
	const { module_name, file_roots } = parse_args(Deno.args);
	const file_paths = await select_files(file_roots);
}

function fail_with_invalid_args() {
	console.log(USAGE);
	Deno.exit(1);
}

function parse_args(ags: string[]) {
	const parsed_args = cli.parseArgs(ags);
	for (const h of ["-h", "--help"]) if (parsed_args[h] !== undefined) fail_with_invalid_args();
	for (const arg of parsed_args._) if (typeof arg !== "string") fail_with_invalid_args();
	const [module_name, ...file_roots] = parsed_args._;
	if (module_name === undefined) fail_with_invalid_args();
	return { module_name, file_roots };
}

/*

cases :
- contains bin             : ask for all bins
- contains dir/files > 1Mb : walk dir

 */

async function* select_files(file_roots: string[]) {
	for (const root of file_roots) {
		const all_files = await discover_files(root);
	}
}

async function* discover_files(root: string) {
	if (await disk_usage(root) > 5_000_000) for await (const selected of prompt_select_per_size(root)) yield selected;
	else for await (const file of walk_dir(root)) yield file;
}

async function* prompt_select_per_size(root: string) {
	throw "todo";
	yield "";
}

async function disk_usage(path: string) {
	throw "todo";
	return 0;
}

await main();
